baleAttacher = {};

function baleAttacher.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

function baleAttacher:load(xmlFile)
	self.searchBales = baleAttacher.searchBales;
	self.searchPallets = baleAttacher.searchPallets;
	self.attachobjects = baleAttacher.attachobjects;
	self.detachobjects = baleAttacher.detachobjects;
	self.OrientJoint = baleAttacher.OrientJoint;
	self.setWorkState = baleAttacher.setWorkState;
	self.isBaleInRange = baleAttacher.isBaleInRange;
	self.isPalletInRange = baleAttacher.isPalletInRange;
	self.place = {};
	self.place.node1 = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.Baletrailer#castPoint1"));		
	self.place.node2 = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.Baletrailer#castPoint2"));
	self.place.attacherNode = Utils.indexToObject(self.components, Utils.getNoNil(getXMLString(xmlFile,"vehicle.Baletrailer#attacherNode"),"0>"));
	self.place.highOffset = Utils.getNoNil(getXMLFloat(xmlFile,"vehicle.Baletrailer#highOffset"),4);	
	self.Attachedobjects = {};
	self.attacherMod = 0;
	self.attacherModOld = 0;
	self.allowAttachment = true;
	self.balesAttached = false;
	self.palletsAttached = false;
end;

function baleAttacher:readStream(streamId, connection)
end;

function baleAttacher:writeStream(streamId, connection)
end;

function baleAttacher:update(dt)
end;

function baleAttacher:updateTick(dt)
	if self:getIsActive() and self.isServer then
		if self.movingDirection ~= 0 then
			if self.balesAttached or self.palletsAttached == false then
				self:setWorkState(false);
			end;
		else
			if self.balesAttached or self.palletsAttached == true then
				self:setWorkState(true);
			end;
		end;
	end;
end;

function baleAttacher:draw()
end;

function baleAttacher:isBaleInRange(node1,node2,Yoffset,Bale)
	local Xmax, Ymax, Zmax = getWorldTranslation(node1);
		  Xmax, Ymax, Zmax = worldToLocal(self.place.attacherNode,Xmax, Ymax, Zmax);
	local Xmin, Ymin, Zmin = getWorldTranslation(node2);	
		  Xmin, Ymin, Zmin = worldToLocal(self.place.attacherNode,Xmin, Ymin, Zmin);
	local Xt, Yt, Zt = getWorldTranslation(Bale);
		  Xt, Yt, Zt = worldToLocal(self.place.attacherNode,Xt, Yt, Zt);
	if (Xt < math.max(Xmax,Xmin) and Xt > math.min(Xmax,Xmin)) and (Zt < math.max(Zmax,Zmin) and Zt > math.min(Zmax,Zmin)) and (Yt<= ((Ymax+Ymin)/2)+Yoffset and Yt>= (Ymax+Ymin)/2) then
		return true;
	else
		return false;
	end;
end;

function baleAttacher:isPalletInRange(node1,node2,Yoffset,Pallet)
	local Xmax, Ymax, Zmax = getWorldTranslation(node1);
		  Xmax, Ymax, Zmax = worldToLocal(self.place.attacherNode,Xmax, Ymax, Zmax);
	local Xmin, Ymin, Zmin = getWorldTranslation(node2);	
		  Xmin, Ymin, Zmin = worldToLocal(self.place.attacherNode,Xmin, Ymin, Zmin);
	local Xt, Yt, Zt = getWorldTranslation(Pallet);
		  Xt, Yt, Zt = worldToLocal(self.place.attacherNode,Xt, Yt, Zt);
	if (Xt < math.max(Xmax,Xmin) and Xt > math.min(Xmax,Xmin)) and (Zt < math.max(Zmax,Zmin) and Zt > math.min(Zmax,Zmin)) and (Yt<= ((Ymax+Ymin)/2)+Yoffset and Yt>= (Ymax+Ymin)/2) then
		return true;
	else
		return false;
	end;
end;

function baleAttacher:searchBales()
	for index,item in pairs(g_currentMission.itemsToSave) do
		if item.item:isa(Bale) then 
			if item.item.isAttached == nil then
				local isInRange = self:isBaleInRange(self.place.node1,self.place.node2,self.place.highOffset,item.item.nodeId);			
				local is1stAttached = false;
				if isInRange then
					is1stAttached = self:attachobjects(item.item.nodeId,item.item);
				end;
				if is1stAttached then
					self.balesAttached = true;
				end;
			end;
		end;
	end;
	for k,v in pairs(g_currentMission.vehicles) do
		if v ~= self and v ~= self.attacherVehicle then
			local is1stAttached = false;
			for index,components in pairs(v.components) do		
				local isInRange = self:isBaleInRange(self.place.node1,self.place.node2,self.place.highOffset,components.node);	
				if isInRange then	
					is1stAttached = self:attachobjects(components.node);
				end;
			end;
			if is1stAttached then
				self.balesAttached = true;
			end;
		end;
	end;
end;

function baleAttacher:searchPallets()
	for index,item in pairs(g_currentMission.itemsToSave) do
		if item.item:isa(Pallet) then 
			if item.item.isAttached == nil then
				local isInRange = self:isPalletInRange(self.place.node1,self.place.node2,self.place.highOffset,item.item.nodeId);			
				local is1stAttached = false;
				if isInRange then
					is1stAttached = self:attachobjects(item.item.nodeId,item.item);
				end;
				if is1stAttached then
					self.palletsAttached = true;
				end;
			end;
		end;
	end;
	for k,v in pairs(g_currentMission.vehicles) do
		if v ~= self and v ~= self.attacherVehicle then
			local is1stAttached = false;
			for index,components in pairs(v.components) do		
				local isInRange = self:isPalletInRange(self.place.node1,self.place.node2,self.place.highOffset,components.node);	
				if isInRange then	
					is1stAttached = self:attachobjects(components.node);
				end;
			end;
			if is1stAttached then
				self.palletsAttached = true;
			end;
		end;
	end;
end;

function baleAttacher:setWorkState(isCoupling,noEventSend)
	if isCoupling then
		self:detachobjects();	
	else
		self:searchBales();
		self:searchPallets();
	end;
end;

function baleAttacher:OrientJoint(Source, Target)	
	local xw, yw, zw = getWorldTranslation(Source);		
	local x,y,z = worldToLocal(getParent(Target), xw, yw, zw);	
	setTranslation(Target, x,y,z);			
	local zX, zY, zZ = localDirectionToWorld(Source, 0,0,1);
	local zX, zY, zZ = worldDirectionToLocal(getParent(Target), zX, zY, zZ);
	local yX, yY, yZ = localDirectionToWorld(Source, 0,1,0);
	local yX, yY, yZ = worldDirectionToLocal(getParent(Target), yX, yY, yZ);
	setDirection(Target, zX, zY, zZ, yX, yY, yZ);
	return false;
end;

function baleAttacher:attachobjects(object,baleT)
	local attachedobject = {};
	attachedobject.object = object;
	if self.isServer then
		attachedobject.AT = createTransformGroup("AT");
		link(self.place.attacherNode,attachedobject.AT);
		self:OrientJoint(object,attachedobject.AT);
		local constr = JointConstructor:new();					
		constr:setActors(self.place.attacherNode, object);
		constr:setJointTransforms(attachedobject.AT,  object);
		for i=1, 3 do
			constr:setTranslationLimit(i-1, true, 0, 0);
			constr:setRotationLimit(i-1,0,0);
		end;
		attachedobject.JointIndex = constr:finalize();
		if baleT ~= nil then
			attachedobject.baleT = baleT;
			baleT.isAttached = true;
			attachedobject.objectMass = getMass(object);
			setMass(object,attachedobject.objectMass*0.6);
		end;
	end;
	table.insert(self.Attachedobjects, attachedobject);
	return true;
end;

function baleAttacher:attachobjects(object,palletT)
	local attachedobject = {};
	attachedobject.object = object;
	if self.isServer then
		attachedobject.AT = createTransformGroup("AT");
		link(self.place.attacherNode,attachedobject.AT);
		self:OrientJoint(object,attachedobject.AT);
		local constr = JointConstructor:new();					
		constr:setActors(self.place.attacherNode, object);
		constr:setJointTransforms(attachedobject.AT,  object);
		for i=1, 3 do
			constr:setTranslationLimit(i-1, true, 0, 0);
			constr:setRotationLimit(i-1,0,0);
		end;
		attachedobject.JointIndex = constr:finalize();
		if palletT ~= nil then
			attachedobject.palletT = palletT;
			palletT.isAttached = true;
			attachedobject.objectMass = getMass(object);
			setMass(object,attachedobject.objectMass*0.6);
		end;
	end;
	table.insert(self.Attachedobjects, attachedobject);
	return true;
end;

function baleAttacher:detachobjects()
	if self.isServer then
		for k,v in pairs(self.Attachedobjects) do
			removeJoint(v.JointIndex);
			delete(v.AT);
			v.JointIndex = nil;
			if v.baleT or v.palletT ~= nil then
				v.baleT.isAttached = nil;
				v.palletT.isAttached = nil;
				setMass(v.object,v.objectMass);
			end;
		end;
	end;
	self.Attachedobjects = nil;
	self.Attachedobjects = {};
	self.balesAttached = false;
	self.palletsAttached = false;
end;

function baleAttacher:onAttach(attacherVehicle)
	if self.isServer then
		self:setWorkState(false);
	end;
end;

function baleAttacher:onDetach()
	if self.isServer then
		self:setWorkState(true);
	end;
end;

function baleAttacher:onActivate()
	if self.isServer then
		self:setWorkState(false);
	end;
end;

function baleAttacher:onDeactivate()
	if self.isServer then
		self:setWorkState(true);
	end;
end;

function baleAttacher:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if not resetVehicles then
	end;
    return BaseMission.VEHICLE_LOAD_OK;
end;

function baleAttacher:getSaveAttributesAndNodes(nodeIdent)
    local attributes = nil;
    local node = nil;
    return attributes, node;
end;

function baleAttacher:delete()
end;

function baleAttacher:mouseEvent(posX, posY, isDown, isUp, button)
end;

function baleAttacher:keyEvent(unicode, sym, modifier, isDown)
end;
